// Version 3  -  BLE-receiver (peripheral)
// ==========================


#include <ArduinoBLE.h>

BLEService dataService("19B10000-E8F2-537E-4F6C-D104768A1214"); // Bluetooth® Low Energy LED Service
// Bluetooth® Low Energy LED Switch Characteristic - custom 128-bit UUID, read and writable by central
BLEByteCharacteristic valueCharacteristic("19B10001-E8F2-537E-4F6C-D104768A1214", BLERead | BLEWrite);

#include <ESP32Servo.h>
Servo servo1;Servo servo2;Servo servo3;Servo servogripper;
int pos = 0; 

float EMA_a = 0.06;      //initialization of EMA alpha
//low α will be very slow to rapid input changes and take many samples into account
//high α will be fast, but average over fewer samples
int EMA_S = 0;          //initialization of EMA S
int checkvalue;


void setup() {
  Serial.begin(115200);
  while (!Serial);
  Serial.println("setup");

  servo1.attach(23);
  servo2.attach(22);

  servogripper.attach(21);

  servo1.write(90);servo2.write(90);servogripper.write(90);
  delay(20);
   
  // begin initialization
  if (!BLE.begin()) {
    Serial.println("starting Bluetooth® Low Energy module failed!");
    while (1);
  }

  // set advertised local name and service UUID:
  BLE.setLocalName("Arm");
  BLE.setAdvertisedService(dataService);

  // add the characteristic to the service
  dataService.addCharacteristic(valueCharacteristic);

  // add service
  BLE.addService(dataService);

  // set the initial value for the characeristic:
  valueCharacteristic.writeValue(0);

  // start advertising
  BLE.advertise();

  Serial.println("BLE Peripheral");
}

void loop() {
  // listen for Bluetooth® Low Energy peripherals to connect:
  BLEDevice central = BLE.central();

  // if a central is connected to peripheral:
  if (central) {
    Serial.print("Connected to central: ");
    // print the central's MAC address:
    Serial.println(central.address());
    delay(1000); // pause a little time

    // while the central is still connected to peripheral:
    while (central.connected()) {
      // if the remote device wrote to the characteristic,
      // use the value
      if (valueCharacteristic.written()) {
        if (valueCharacteristic.value()) {   // any value other than 0
          int showValue = valueCharacteristic.value();
          showValue = map(showValue, 70,160, 160, 60); //depends on your servo if you use 0-180 or 180-0
          if (showValue < 60) (showValue = 60);
          if (showValue > 160) (showValue = 160);

          EMA_S = (EMA_a*showValue) + ((1-EMA_a)*EMA_S);      // filter to make movements smooth
          //Serial.println(EMA_S);
          
          if ((EMA_S > (checkvalue+15)) || (EMA_S > (checkvalue+15))) {  //prevent sudden moves
            EMA_S = EMA_S + ((EMA_S-checkvalue)/2);
          }

          Serial.println(showValue);
          servogripper.write(EMA_S);
          checkvalue = EMA_S;
          delay(10);
        }
      }
    }

    // when the central disconnects, print it out:
    Serial.print(F("Disconnected from central: "));
    Serial.println(central.address());
  }
}
